# Translator.py - code for the Translator product
#
# Copyright (C) 2000 J. David Ibez, Andres Marzal <al028823@alumail.uji.es>
# Copyright (C) 2000 Federico Di Gregorio  <fog@mixadlive.com>
# Copyright (C) 2000 MIXAD LIVE S.r.l.  [http://www.mixadlive.com]
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# -*- Mode: pyhton -*-

__doc__ = """Translator"""
__version__ = '0.3'
__author__ = """J. David Ibez <al028823@alumail.uji.es>
                Federico Di Gregorio <fog@mixadlive.com>"""


import sys, string, types
from string import split, strip, join

# zope specific imports
import Globals
from DocumentTemplate.DT_Util import *
from DocumentTemplate.cDocumentTemplate import TemplateDict
from OFS import Folder


class LocalizeTag:
    """dtml-localize implementation."""
    
    name = 'localize'
    
    def __init__(self, args):
        """Initialization code."""
        if args[:9] == 'localize ': args = args[9:]
        args = parse_params(args, name='', expr='')
        self.args = args
        name, expr = name_param(args, 'localize', 1)
        self.__name__, self.expr = name, expr
        

    def __get_translators__(self, md):
        """This is black magic. Don't ask me why it works..."""
        rev = [] ; trans = []
        ma = md._pop()
        while ma:
            try:
                f = ma['this']()
                #sys.stderr.write('LocalizeTag: f = %s\n' % `f`)
                trans = trans + f.superValues('Translator')
                #sys.stderr.write('LocalizeTag: trans = %s\n' % `trans`)
            except:
                pass
            rev.append(ma)
            try:
                ma = md._pop()
            except:
                break
        rev.reverse()
        for r in rev:
            md._push(r)
        return trans
        

    def render(self, md):
        """Render the content by looking for a translator."""
        if self.expr: val = self.expr.eval(md)
        else: val = self.__name__
        translators = self.__get_translators__(md)
        for t in translators:
            try:
                return t.translate(val)
            except AttributeError:
                pass
        raise AttributeError(val)
    

    # this make the tag to render (localize) on call
    __call__ = render



