# Translator.py - code for the Translator product
#
# Copyright (C) 2000 J. David Ibez, Andres Marzal <al028823@alumail.uji.es>
# Copyright (C) 2000 Federico Di Gregorio  <fog@mixadlive.com>
# Copyright (C) 2000 MIXAD LIVE S.r.l.  [http://www.mixadlive.com]
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# -*- Mode: pyhton -*-

__doc__ = """Translator"""
__version__ = '0.3'
__author__ = """J. David Ibez <al028823@alumail.uji.es>
                Federico Di Gregorio <fog@mixadlive.com>"""


import sys, string
from string import split, strip, join

# zope specific imports
from DocumentTemplate.DT_Util import *


class TranslateTag:
    """dtml-translate implementation."""
    
    name = 'translate'
    blockContinuations = ()

    
    def __init__(self, blocks):
        """Initialization code."""
        tname, args, section = blocks[0]
        self.section = section.blocks
        

    def render(self, md):
        ns = namespace(self)[0]
        md._push(InstanceDict(ns, md))

        try:
            s = render_blocks(self.section, md)
        finally:
            md._pop(1)
            pass

        list_of_words = split(s)
        translation = []

        for word in list_of_words:
            expression = VSEval.Eval("translator('%s')" % word, expr_globals)
            translation.append(expression.eval(md))

        return join(translation)


    # this make the tag to render (translate) on call)
    __call__ = render

