# __init__.py - initialization routines for the L10NFolder product
#
# Copyright (C) 2000 J. David Ibez, Andres Marzal <al028823@alumail.uji.es>
# Copyright (C) 2000 Federico Di Gregorio  <fog@mixadlive.com>
# Copyright (C) 2000 MIXAD LIVE S.r.l.  [http://www.mixadlive.com]
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# -*- Mode: pyhton -*-

__doc__ = """Translator"""
__version__ = '0.3'
__author__ = """J. David Ibez <al028823@alumail.uji.es>
                Federico Di Gregorio <fog@mixadlive.com>"""


from DocumentTemplate.DT_String import String

import Translator
import TranslateTag
import LocalizeTag


def initialize(context):
    Translator._trace('__init__: initializing Translator product')
    try:
        constructors_list = (Translator.manage_addTranslatorForm,
                             Translator.manage_addTranslator)
        context.registerClass(Translator.Translator,
                              constructors = constructors_list,
                              icon = 'translator.gif')
        Translator._trace('__init__: adding dtml-translate tag')
        String.commands['translate'] = TranslateTag.TranslateTag
        Translator._trace('__init__: adding dtml-localize tag')
        String.commands['localize'] = LocalizeTag.LocalizeTag
        Translator._trace('__init__: Translator product complete')
    except:
        import sys, traceback, string
        print 'import'
        type, val, tb = sys.exc_info()
        print 'info'
        errmsg = string.join(traceback.format_exception(type, val, tb), '')
        print 'errmsg'
        print errmsg
        Translator._trace(errmsg)
        del type, val, tb
                                              

